local t = Def.ActorFrame {
	LoadFont("Common Normal") .. {
		Name="SpeedModP1";
		InitCommand=cmd(zoom,0.5;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y-173;diffuse,1,1,1,1;strokecolor,Color("Black"));
	};
	LoadFont("Common Normal") .. {
		Name="SpeedDisp1";
		InitCommand=cmd(zoom,0.5;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y-186;diffuse,1,1,1,1;strokecolor,Color("Black"));
	};
	LoadFont("Common Normal") .. {
		Name="SpeedModP2";
		InitCommand=cmd(zoom,0.5;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y-173;diffuse,1,1,1,1;strokecolor,Color("Black"));
	};
	LoadFont("Common Normal") .. {
		Name="SpeedDisp2";
		InitCommand=cmd(zoom,0.5;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y-186;diffuse,1,1,1,1;strokecolor,Color("Black"));
	};
};

local function Update(self)

	if GAMESTATE:IsHumanPlayer(PLAYER_1) then
	
		local speedmodp1 = self:GetChild("SpeedModP1");
		local speeddisp1 = self:GetChild("SpeedDisp1");
		local displayp1 = GetUserPref("SpeedDisplayP1");
		
		local speed1p1;
		if GetUserPrefN("SpeedMod1P1") ~= nil then
			speed1p1 = (GetUserPrefN("SpeedMod1P1"));
		else
			speed1p1 = 1;
		end;
		
		local speed2p1;
		if GetUserPrefN("SpeedMod2P1") ~= nil then
			speed2p1 = (GetUserPrefN("SpeedMod2P1"));
		else
			speed2p1 = 0;
		end;
		
		local speed3p1;
		if GetUserPrefN("SpeedMod3P1") ~= nil then
			speed3p1 = (GetUserPrefN("SpeedMod3P1"));
		else
			speed3p1 = 0;
		end;
		
		local speedp1 = speed1p1 .. speed2p1 .. speed3p1;
		
		local optionsp1 = GAMESTATE:GetPlayerState(PLAYER_1):GetPlayerOptionsString("ModsLevel_Preferred");
		if displayp1 == "1" then
			speedmodp1:settext( "Actual SpeedMod: C" .. speedp1 );
			speeddisp1:settext( "Average BPM: " .. speedp1 );
			GAMESTATE:GetPlayerState(PLAYER_1):SetPlayerOptions('ModsLevel_Preferred', optionsp1 .. ",C" .. speedp1);
		elseif displayp1 == "2" then
			speedmodp1:settext( "Actual SpeedMod: " .. speedp1/100 .. "x" );
			speeddisp1:settext( "Average BPM: " .. string.format("%03.0f", AverageBPM()*(speedp1/100)) );
			GAMESTATE:GetPlayerState(PLAYER_1):SetPlayerOptions('ModsLevel_Preferred', optionsp1 .. "," .. speedp1/100 .. "x");
		elseif displayp1 == "3" then
			speedmodp1:settext( "Actual SpeedMod: A" .. speedp1 );
			speeddisp1:settext( "Average BPM: " .. speedp1 );
			GAMESTATE:GetPlayerState(PLAYER_1):SetPlayerOptions('ModsLevel_Preferred', optionsp1 .. "," .. speedp1/AverageBPM() .."x");
		elseif displayp1 == "4" then
			speedmodp1:settext( "Actual SpeedMod: CX" .. speedp1 );
			speeddisp1:settext( "Average BPM: " .. speedp1 );
		else
			speedmodp1:settext( "Actual SpeedMod: M" .. speedp1 );
			speeddisp1:settext( "Average BPM: " .. speedp1 );
			GAMESTATE:GetPlayerState(PLAYER_1):SetPlayerOptions('ModsLevel_Preferred', optionsp1 .. ",M" .. speedp1);
		end;
		--if GAMESTATE:GetNumPlayersEnabled() == 2 then
			speedmodp1:x(SCREEN_CENTER_X-100);
			speeddisp1:x(SCREEN_CENTER_X-100);
		--end;
	end;
	if GAMESTATE:IsHumanPlayer(PLAYER_2) then
	
		local speedmodp2 = self:GetChild("SpeedModP2");
		local speeddisp2 = self:GetChild("SpeedDisp2");
		local displayp2 = GetUserPref("SpeedDisplayP2");
		
		local speed1p2;
		if GetUserPrefN("SpeedMod1P2") ~= nil then
			speed1p2 = (GetUserPrefN("SpeedMod1P2"));
		else
			speed1p2 = 1;
		end;
		
		local speed2p2;
		if GetUserPrefN("SpeedMod2P2") ~= nil then
			speed2p2 = (GetUserPrefN("SpeedMod2P2"));
		else
			speed2p2 = 0;
		end;
		
		local speed3p2;
		if GetUserPrefN("SpeedMod3P2") ~= nil then
			speed3p2 = (GetUserPrefN("SpeedMod3P2"));
		else
			speed3p2 = 0;
		end;
		
		local speedp2 = speed1p2 .. speed2p2 .. speed3p2;
		
		local optionsp2 = GAMESTATE:GetPlayerState(PLAYER_2):GetPlayerOptionsString("ModsLevel_Preferred");
		if displayp2 == "1" then
			speedmodp2:settext( "Actual SpeedMod: C" .. speedp2 );
			speeddisp2:settext( "Average BPM: " .. speedp2 );
			GAMESTATE:GetPlayerState(PLAYER_2):SetPlayerOptions('ModsLevel_Preferred', optionsp2 .. ",C" .. speedp2);
		elseif displayp2 == "2" then
			speedmodp2:settext( "Actual SpeedMod: " .. speedp2/100 .. "x" );
			speeddisp2:settext( "Average BPM: " .. string.format("%03.0f", AverageBPM()*(speedp2/100)) );
			GAMESTATE:GetPlayerState(PLAYER_2):SetPlayerOptions('ModsLevel_Preferred', optionsp2 .. "," .. speedp2/100 .. "x");
		elseif displayp2 == "3" then
			speedmodp2:settext( "Actual SpeedMod: A" .. speedp2 );
			speeddisp2:settext( "Average BPM: " .. speedp2 );
			GAMESTATE:GetPlayerState(PLAYER_2):SetPlayerOptions('ModsLevel_Preferred', optionsp2 .. "," .. speedp2/AverageBPM() .."x");
		elseif displayp2 == "4" then
			speedmodp2:settext( "Actual SpeedMod: CX" .. speedp2 );
			speeddisp2:settext( "Average BPM: " .. speedp2 );
		else
			speedmodp2:settext( "Actual SpeedMod: M" .. speedp2 );
			speeddisp2:settext( "Average BPM: " .. speedp2 );
			GAMESTATE:GetPlayerState(PLAYER_2):SetPlayerOptions('ModsLevel_Preferred', optionsp2 .. ",M" .. speedp2);
		end;
		--if GAMESTATE:GetNumPlayersEnabled() == 2 then
			speedmodp2:x(SCREEN_CENTER_X+100);
			speeddisp2:x(SCREEN_CENTER_X+100);
		--end;
	end;
end;

t.InitCommand=cmd(SetUpdateFunction,Update);

return t;